AllDigital

Define SPI_CS_REG = PORTC
Define SPI_CS_BIT = 0
Define SPI_SCK_REG = PORTC
Define SPI_SCK_BIT = 3
Define SPI_SDI_REG = PORTC
Define SPI_SDI_BIT = 5
Define SPI_SDO_REG = PORTC
Define SPI_SDO_BIT = 4
SPIPrepare  'sends 8 clks, while s0 is low


Dim addr As Word  '0 to 511
Dim data As Byte
Dim pntr As Byte
Dim cntr As Byte
Dim paws As Byte


main1:

Gosub writebyte
Gosub wrdi  'disables writes

Gosub writestr
Gosub wrdi

Gosub writemsg1
Gosub wrdi

Goto main1


End                                               

'fill ram with 0 thru 255, starting at 256
writebyte:
addr = 0  'starting address
SPICSOn
SPISend 6  'set WREN latch in i/c
SPICSOff

write1:
For cntr = 0 To 255
SPICSOn
SPISend %00001010  'write command, with a8 set
Gosub pause
SPISend addr
Gosub pause
SPISend addr  'data= addr value
SPICSOff
addr = addr + 1
Next cntr
Return                                            


'write part page, using 25C040 internal addr incrementing
'REM: a page is xxxx,0000 thru xxxx,1111 == 16 bytes
writestr:
addr = 0
SPICSOn
SPISend 6  'set WREN latch in i/c
SPICSOff

SPICSOn
SPISend 2  'write command
Gosub pause
SPISend addr
Gosub pause
For pntr = 0 To 9
data = LookUp("0123456789"), pntr
SPISend data
Next pntr
SPICSOff

'reverse string
SPICSOn
SPISend 2  'write
Gosub pause
SPISend 0x10  'addr0
Gosub pause
For pntr = 0 To 9
data = LookUp("9876543210"), pntr
SPISend data
Gosub pause
Next pntr
SPICSOff
Return                                            


'write test string
writemsg1:
addr = 0  'starting address
SPICSOn
SPISend 6  'set WREN latch in i/c
SPICSOff

For pntr = 0 To 43
SPICSOn
SPISend %00001010  'write command, with a8 set == ram  256+
Gosub pause
SPISend addr
Gosub pause
data = LookUp("The Quick Brown Fox Jumps Over The Lazy Dog."), pntr
SPISend data
SPICSOff
addr = addr + 1
Next pntr
Return                                            

wrdi:
SPICSOn
SPISend %00000100  'rest WREN latch
SPICSOff
Return                                            


'just to slow things down for observer!.
pause:
For paws = 0 To 1
PORTB = 0
Next paws
Return                                            
