AllDigital
'TRISB = 0
'PORTB = 0xff
Define SPI_CS_REG = PORTC
Define SPI_CS_BIT = 0
Define SPI_SCK_REG = PORTC
Define SPI_SCK_BIT = 3
Define SPI_SDI_REG = PORTC
Define SPI_SDI_BIT = 4  '5
Define SPI_SDO_REG = PORTC
Define SPI_SDO_BIT = 5  '4
SPIPrepare  'sends 8 clks, while s0 is low


Dim addr As Word  '0 to 511
Dim data As Byte
Dim pntr As Byte
Dim cntr As Byte
Dim paws As Byte
Dim show As Byte

main1:
Gosub readbyte
Gosub pause
Goto main1

'Gosub writemsg1
'Gosub wrdi

Gosub readbyte
Gosub wrdi  'disables writes

Gosub writestr
Gosub wrdi

Goto main1


End                                               


readbyte:

For addr = 0 To 10
SPICSOn
SPISend 0x03
SPISend addr.LB
Gosub pause
'Break
SPIReceive data
Gosub pause
show = data
'Gosub pause
'show = ShiftLeft(data, 8)
Gosub pause
SPICSOff
'Gosub pause
Next addr
Return                                            



'write byte by byte to ram
writebyte:
addr = 0x00  'starting address
SPICSOn
SPISend 6  'set WREN latch in i/c
SPICSOff

write1:
For cntr = 0 To 9
SPICSOn
SPISend %00000010  'write command
'Gosub pause
SPISend addr.LB
'Gosub pause
SPISend addr.LB  'data= addr.lb value
SPICSOff
addr = addr + 1
Next cntr
Return                                            


'write part page, using 25C040 internal addr incrementing
'REM: a page is xxxx,0000 thru xxxx,1111 == 16 bytes
writestr:
addr = 0x20
SPICSOn
SPISend 6  'set WREN latch in i/c
SPICSOff

SPICSOn
SPISend 2  'write command
'Gosub pause
SPISend addr.LB
'Gosub pause
For pntr = 0 To 9
data = LookUp("0123456789"), pntr
SPISend data
Next pntr
SPICSOff

'reverse string
SPICSOn
SPISend 2  'write
Gosub pause
SPISend 0x20  'addr0
'Gosub pause
For pntr = 0 To 9
data = LookUp("9876543210"), pntr
SPISend data
'Gosub pause
Next pntr
SPICSOff
Return                                            


'write test string
writemsg1:
addr = 0x40  'starting address
SPICSOn
SPISend 6  'set WREN latch in i/c
SPICSOff

For pntr = 0 To 43
SPICSOn
SPISend %00000010  'write command
'Gosub pause
SPISend addr.LB
'Gosub pause
data = LookUp("The Quick Brown Fox Jumps Over The Lazy Dog."), pntr
SPISend data
SPICSOff
addr = addr + 1
Next pntr

addr = 0x40
For pntr = 43 To 0 Step -1
SPICSOn
SPISend 2
data = LookUp("THE QUICK BROWN FOX JUMPS OVER THE LAZY DOG."), pntr
SPISend data
SPICSOff
addr = addr + 1
Next pntr

Return                                            

wrdi:
SPICSOn
SPISend %00000100  'rest WREN latch
SPICSOff
Return                                            


'just to slow things down for observer!.
pause:
For paws = 0 To 20
PORTB = 0
Next paws
Return                                            
